#PBForms Created
'--------------------------------------------------------------------------------
' The first line in this file is a PBForms metastatement.
' It should ALWAYS be the first line of the file. Other
' PBForms metastatements are placed at the beginning and
' ending of blocks of code that should be edited using
' PBForms only. Do not edit or delete these
' metastatements or PBForms will not be able to reread
' the file correctly. See the PBForms documentation for
' more information.
' Beginning blocks begin like this: #PBForms Begin ...
' Ending blocks begin like this:    #PBForms End ...
' Other PBForms metastatements such as:
'     #PBForms Declarations
' are used to tell PBForms where to insert additional
' code. Feel free to make changes anywhere else in the file.
'--------------------------------------------------------------------------------

#Compile Exe
#Dim All

'--------------------------------------------------------------------------------
'   ** Includes **
'--------------------------------------------------------------------------------
#PBForms Begin Includes
#If Not %Def(%WINAPI)
    #Include "WIN32API.INC"
#EndIf
#Include "PBForms.INC"
#PBForms End Includes
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   ** Constants **
'--------------------------------------------------------------------------------
#PBForms Begin Constants
%IDD_Form1                  = 101
%IDC_chkDefExamples         = 1001
%IDC_chkExprEvalExamples    = 1002
%IDC_txtPlotEq              = 1003
%IDC_btnPlot                = 1004
%IDC_Picture1               = 1005
%IDC_txtSumMax              = 1006
%IDC_btnSum                 = 1007
%IDC_txtSumResult           = 1008
%IDC_txtSumExpression       = 1009
%IDC_btnDefine              = 1010
%IDC_txtDefinition          = 1011
%IDC_btnEval                = 1012
%IDC_txtResult              = 1013
%IDC_txtExpression          = 1014
%IDC_lblSumResult           = 1015
%IDC_lblSumExpression       = 1016
%IDC_Label2                 = 1017
%IDC_lblSpeedTest           = 1018
%IDC_lbl_UserDef            = 1019
%IDC_lbl_ExprEval           = 1020
%IDC_lblElapsed             = 1021
%IDC_Label1                 = 1022
%IDC_lblDefineSource2       = 1023
%IDC_lblDefineSource        = 1024
%IDC_lblDefinition          = 1025
%IDC_lblEvalSource2         = 1026
%IDC_lblEvalSource          = 1027
%IDC_lblResult              = 1028
%IDC_lblExpression          = 1029
%IDC_lblFPU                 = 1030
%IDC_chkInvalidOp           = 1031
%IDC_chkDenormalOp          = 1032
%IDC_chkDivisionBy0         = 1033
%IDC_chkOverflow            = 1034
%IDC_chkUnderflow           = 1035
%IDC_chkPrecisionLoss       = 1036
#PBForms End Constants
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   ** Declarations **
'--------------------------------------------------------------------------------
Declare CallBack Function ShowForm1Proc()
Declare Function ShowForm1(ByVal hParent As Dword) As Long
#PBForms Declarations
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
#Include "uCalcPB.bas"

Global Ps As PAINTSTRUCT
Global Rct As RECT

Sub SpeedTest(ByVal hDlg As Dword)
   Dim Expression As String, txtSumMax As String
   Dim ExprPtr As Dword, xPtr As Dword
   Dim x As Extended, SumTotal As Extended, SumMax As Extended
   Dim TimerStart As Single, TimerEnd As Single

   Control Get Text hDlg, %IDC_txtSumExpression To Expression
   Control Get Text hDlg, %IDC_txtSumMax To txtSumMax

   xPtr = ucDefineVariable("x As Extended", VarPtr(x))
   ExprPtr = ucParse(Expression)

   SumMax = Val(txtSumMax)
   TimerStart = Timer

   For x = 1 To SumMax
      SumTotal = SumTotal + ucEvaluate(ExprPtr)
   Next

   TimerEnd = Timer - TimerStart
   Control Set Text hDlg, %IDC_txtSumResult, Str$(SumTotal, 18)
   Control Set Text hDlg, %IDC_lblElapsed, "Elapsed Time: " + Format$(TimerEnd, "0.00") + " seconds"

   ucReleaseItem ExprPtr
   ucReleaseItem xPtr
End Sub

Sub CartesianLineTo(ByVal hDc As Long, ByVal x As Single, y As Single)
   Dim NewX As Long, NewY As Long

   NewX = 205 * (x + 10) / 20
   NewY = 100 * (2 - y) / 4

   If x = -10 Or NewY > 99 Or NewY < 0 _
   Then MoveToEx hDc, NewX, Min&(Max&(NewY, 0), 99), ByVal %NULL _
   Else LineTo hDc, NewX, NewY
End Sub

Sub PlotGraph(ByVal hDlg As Dword)
    Dim x As Double, EqPtr As Long, xPtr As Long
    Dim hDc As Long
    Dim Equation$

    hDC = GetDC(GetDlgItem(hDlg, %IDC_Picture1))
    Rct.nRight = 205 : Rct.nBottom = 100
    FillRect hDC, Rct, 1

    Control Get Text hDlg, %IDC_txtPlotEq To Equation$

    xPtr = ucDefineVariable("x As Double", VarPtr(x))
    EqPtr = ucParse(Equation$)

    For x = -10 To 10 Step 0.125
       CartesianLineTo hDc, x, ucEvaluate(EqPtr)
    Next

    ucReleaseItem EqPtr
    ucReleaseItem xPtr

    ReleaseDC GetDlgItem(hDlg, %IDC_Picture1), hDC
End Sub

' uCalc callback routines
Function MyEasyCallback(ByVal a As Double, ByRef b As Long, ByVal c As Byte) As Extended
   MyEasyCallback = a + b + c
End Function

Function MyIIF(ByVal cond As Long, ByVal TruePart As Long, ByVal FalsePart As Long) As Extended
   If cond Then MyIIF = ucEvaluate(TruePart) Else MyIIF = ucEvaluate(FalsePart)
End Function

Function MyIIFStr(ByVal cond As Long, ByVal TruePart As Long, ByVal FalsePart As Long) As String
   If cond Then MyIIFStr = ucEvaluateStr(TruePart) Else MyIIFStr = ucEvaluateStr(FalsePart)
End Function

Function MyMsgBox(ByVal Prompt As Long, ByVal Buttons As Long, ByVal Title As Long) As Long
   MyMsgBox = MsgBox(ucEvaluateStr(Prompt), Buttons, ucEvaluateStr(Title))
End Function

Function MyMsgBoxB(ByRef Prompt As String, ByVal Buttons As Long, ByRef Title As String) As Long
   MyMsgBoxB = MsgBox(Prompt, Buttons, Title)
End Function

' Callbacks using ucParam, and ucReturn are less efficient
Sub MyAverage(ByVal Expr As Dword)
   Dim x As Long, Total As Double

   For x = 1 To ucParamCount(Expr)
      Total = Total + ucParamDbl(Expr, x)
   Next

   ucReturnDbl(Expr, Total / ucParamCount(Expr))
End Sub

Sub MyLeft(ByVal Expr As Dword)
    ucReturnStr Expr, Left$(ucParamStr(Expr, 1), ucParamDbl(Expr, 2))
End Sub


Function StringMult(ByRef MyString As String, ByVal Number As Long) As String
   Dim x As Long, TotalString As String

   For x = 1 To Number
      TotalString = TotalString + MyString
   Next

   StringMult = TotalString
End Function


Function PBMain()
   ucDefineFunction "MyEasyCallback(ByVal a As Double, ByRef b As Long, ByVal c As Byte) As Extended", CodePtr(MyEasyCallback)
   ucDefineFunction "MyIIf(ByVal cond As Long, ByExpr TruePart, ByExpr FalsePart) As Extended", CodePtr(MyIIF)
   ucDefineFunction "MyIIf(ByVal cond As Long, ByExpr TruePart As String, ByExpr FalsePart As String) As String", CodePtr(MyIIFStr)
   ucDefineFunction "MyMsgBox(ByExpr Prompt As String, ByVal Buttons As Long = 0, ByExpr Title As String = 'uCalc') As Long", CodePtr(MyMsgBox)
   ucDefineFunction "MyMsgBoxB(ByRef Prompt As String, ByVal Buttons As Long = 0, ByRef Title As String = 'uCalc') As Long", CodePtr(MyMsgBoxB)

'   ucDefineOperator "Precedence('*') {ByRef MyString As String} * {ByVal Number As Long} As String", CodePtr(StringMult)
   ucDefineOperator "20 {ByRef MyString As String} * {ByVal Number As Long} As String", CodePtr(StringMult)
 
   ucDefine "Func:: MyAverage(x As Double ...) As Double", CodePtr(MyAverage)
   ucDefine "Func:: MyLeft(Text As String, Count As Double) As String", CodePtr(MyLeft)

    ShowForm1 %HWND_DESKTOP
End Function
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   ** CallBacks **
'--------------------------------------------------------------------------------
CallBack Function ShowForm1Proc()
    Dim txt$, Discard As Long

    Select Case CbMsg
        Case %WM_COMMAND
            Select Case CbCtl
                Case %IDC_txtExpression
                   Control Get Text CbHndl, %IDC_txtExpression To txt$
                   Control Set Text CbHndl, %IDC_lblEvalSource, "Expression = """ + txt$ + """"
                Case %IDC_txtDefinition
                   Control Get Text CbHndl, %IDC_txtDefinition To txt$
                   Control Set Text CbHndl, %IDC_lblDefineSource, "Definition = """ + txt$ + """"
                Case %IDC_btnEval
                    If CbCtlMsg = %BN_CLICKED Then
                       Control Get Text CbHndl, %IDC_txtExpression To txt$
                       Control Set Text CbHndl, %IDC_txtResult, ucEvalStr(txt$)
                    End If
                Case %IDC_btnDefine
                    If CbCtlMsg = %BN_CLICKED Then
                       Control Get Text CbHndl, %IDC_txtDefinition To txt$
                       ucDefine txt$
                    End If
                Case %IDC_btnSum
                    If CbCtlMsg = %BN_CLICKED Then
                       Call SpeedTest(CbHndl)
                    End If
                Case %IDC_btnPlot
                    If CbCtlMsg = %BN_CLICKED Then
                        Call PlotGraph(CbHndl)
                    End If
                Case %IDC_chkExprEvalExamples
                   Discard = Shell(Environ$("Comspec") + " /C NotePad DemoExpr.Txt")
                Case %IDC_chkDefExamples
                   Discard = Shell(Environ$("Comspec") + " /C NotePad DemoDefs.Txt")
                Case %IDC_chkInvalidOp
                   uCalc %uc_ToggleFPU, 0, %uc_FPU_Mask_InvalidOp
                Case %IDC_chkDenormalOp
                   uCalc %uc_ToggleFPU, 0, %uc_FPU_Mask_DenormalOp
                Case %IDC_chkDivisionBy0
                   uCalc %uc_ToggleFPU, 0, %uc_FPU_Mask_ZeroDivide
                Case %IDC_chkOverflow
                   uCalc %uc_ToggleFPU, 0, %uc_FPU_Mask_Overflow
                Case %IDC_chkUnderflow
                   uCalc %uc_ToggleFPU, 0, %uc_FPU_Mask_Underflow
                Case %IDC_chkPrecisionLoss
                   uCalc %uc_ToggleFPU, 0, %uc_FPU_Mask_PrecisionLoss
            End Select
    End Select

End Function
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   ** Dialogs **
'--------------------------------------------------------------------------------
Function ShowForm1(ByVal hParent As Dword) As Long
    Local lRslt As Long
#PBForms Begin Dialog %IDD_Form1->->
    Local hDlg As Dword
    Local hFont1 As Dword
    Local hFont2 As Dword


    Dialog New hParent, "uCalc FMP 2.9 PowerBASIC " + _
        "Demo", 153, 106, 430, 240, %WS_POPUP Or %WS_BORDER Or %WS_DLGFRAME Or _
        %WS_SYSMENU Or %WS_CLIPSIBLINGS Or %WS_CLIPCHILDREN Or %WS_VISIBLE Or _
        %DS_3DLOOK Or %DS_NOFAILCREATE Or %DS_SETFONT, %WS_EX_WINDOWEDGE Or _
        %WS_EX_CONTROLPARENT Or %WS_EX_APPWINDOW Or %WS_EX_LEFT Or _
        %WS_EX_LTRREADING Or %WS_EX_RIGHTSCROLLBAR, To hDlg
    Control Add TextBox, hDlg, %IDC_txtExpression, "3+4/5-8", 64, 30, 145, 11
    Control Add TextBox, hDlg, %IDC_txtDefinition, "Var: MyVariable = 1234.5", _
        272, 30, 139, 11
    Control Add TextBox, hDlg, %IDC_txtSumMax, "100000", 145, 150, 54, 12
    Control Add TextBox, hDlg, %IDC_txtSumExpression, "x^2+5*x-10", 60, 166, _
        139, 12
    Control Add TextBox, hDlg, %IDC_txtPlotEq, "-sin(x)/2", 268, 136, 139, 12
    Control Add Label, hDlg, %IDC_lblExpression, "User Expression:", 5, 30, 55, _
        10
    Control Add Label, hDlg, %IDC_lblResult, "Result:", 35, 45, 25, 11
    Control Add TextBox, hDlg, %IDC_txtResult, "", 64, 44, 145, 12
    Control Add Label, hDlg, %IDC_lblEvalSource, "Expression = ""3+4/5-8""", 64, _
        5, 139, 10
    Control Add Label, hDlg, %IDC_lblEvalSource2, "Result = " + _
        "ucEvalStr(Expression)", 64, 15, 139, 10
    Control Add Button, hDlg, %IDC_btnEval, "Evaluate", 64, 59, 38, 15
    Control Add Label, hDlg, %IDC_lblDefinition, "Definition:", 235, 30, 30, 10
    Control Add Button, hDlg, %IDC_btnDefine, "Define", 272, 44, 43, 16
    Control Add Label, hDlg, %IDC_lblDefineSource, "Definition = ""Var: " + _
        "MyVariable = 1234.5""", 272, 5, 139, 10
    Control Add Label, hDlg, %IDC_lblDefineSource2, "ucDefine Definition", 272, _
        15, 139, 10
    Control Add TextBox, hDlg, %IDC_txtSumResult, "", 60, 181, 139, 11
    Control Add Button, hDlg, %IDC_btnSum, "Start", 60, 195, 27, 16
    Control Add Label, hDlg, %IDC_Label1, "Summation from 1 to", 66, 153, 75, 7
    Control Add Label, hDlg, %IDC_lblElapsed, "Elapsed Time: 0 seconds", 97, _
        210, 102, 11
    Control Add Image, hDlg, %IDC_Picture1, "", 268, 151, 138, 62, %WS_CHILD Or _
        %WS_VISIBLE Or %WS_BORDER Or %SS_BITMAP Or %SS_CENTERIMAGE
    Control Add Button, hDlg, %IDC_btnPlot, "Plot", 266, 218, 33, 16
    Control Add Label, hDlg, %IDC_lbl_ExprEval, "Expression Evaluator", 107, 59, _
        100, 11
    Control Set Color hDlg, %IDC_lbl_ExprEval, RGB(8, 0, 0), RGB(192, 255, 192)
    Control Add Label, hDlg, %IDC_lbl_UserDef, "User Definitions", 325, 44, 76, _
        11
    Control Set Color hDlg, %IDC_lbl_UserDef, RGB(8, 0, 0), RGB(192, 255, 192)
    Control Add Label, hDlg, %IDC_lblSpeedTest, "Speed Test", 97, 195, 56, 12
    Control Set Color hDlg, %IDC_lblSpeedTest, RGB(8, 0, 0), RGB(192, 255, 192)
    Control Add Label, hDlg, %IDC_Label2, "Equation Plotter", 309, 218, 75, 11
    Control Set Color hDlg, %IDC_Label2, RGB(8, 0, 0), RGB(192, 255, 192)
    Control Add CheckBox, hDlg, %IDC_chkExprEvalExamples, "Show list of sample " + _
        "expressions", 107, 79, 118, 10
    Control Add CheckBox, hDlg, %IDC_chkDefExamples, "Show list of sample user " + _
        "definitions", 272, 64, 139, 10
    Control Add Label, hDlg, %IDC_lblSumExpression, "Expression:", 16, 168, 43, _
        10
    Control Add Label, hDlg, %IDC_lblSumResult, "Sum Result:", 16, 183, 40, 10
    Control Add Label, hDlg, %IDC_lblFPU, "FPU exception masks", 270, 85, 100, _
        10
    Control Add CheckBox, hDlg, %IDC_chkInvalidOp, "Invalid Op", 270, 95, 60, 10
    Control Add CheckBox, hDlg, %IDC_chkDenormalOp, "Denormal Op", 270, 105, 60, _
        10
    Control Add CheckBox, hDlg, %IDC_chkDivisionBy0, "Division By 0", 270, 115, _
        55, 10
    Control Add CheckBox, hDlg, %IDC_chkOverflow, "Overflow", 345, 95, 60, 10
    Control Add CheckBox, hDlg, %IDC_chkUnderflow, "Underflow", 345, 105, 60, 10
    Control Add CheckBox, hDlg, %IDC_chkPrecisionLoss, "Precision Loss", 345, _
        115, 60, 10

    hFont1 = PBFormsMakeFont("MS Sans Serif", 10, 700, %FALSE, %FALSE, %FALSE, %ANSI_CHARSET)
    hFont2 = PBFormsMakeFont("MS Sans Serif", 8, 400, %TRUE, %FALSE, %FALSE, %ANSI_CHARSET)

    Control Send hDlg, %IDC_lbl_ExprEval, %WM_SETFONT, hFont1, 0
    Control Send hDlg, %IDC_lbl_UserDef, %WM_SETFONT, hFont1, 0
    Control Send hDlg, %IDC_lblSpeedTest, %WM_SETFONT, hFont1, 0
    Control Send hDlg, %IDC_Label2, %WM_SETFONT, hFont1, 0
    Control Send hDlg, %IDC_lblFPU, %WM_SETFONT, hFont2, 0

#PBForms End Dialog

    Control Set Check hDlg, %IDC_chkInvalidOp, 1
    Control Set Check hDlg, %IDC_chkDenormalOp, 1
    Control Set Check hDlg, %IDC_chkDivisionBy0, 1
    Control Set Check hDlg, %IDC_chkOverflow, 1
    Control Set Check hDlg, %IDC_chkUnderflow, 1
    Control Set Check hDlg, %IDC_chkPrecisionLoss, 1

    Dialog Show Modal hDlg, Call ShowForm1Proc To lRslt

    DeleteObject hFont1

    Function = lRslt
End Function
'--------------------------------------------------------------------------------
