// DemoVCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DemoVC.h"
#include "DemoVCDlg.h"
#include "uCalcCPP.cpp"
// ---> NOTE: Be sure to copy uCalcCPP.* and *.DLL as well as *.Txt
//            to the DemoVC directory

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

double W, H;
void CartesianLineTo(CDC* pDC, double X, double Y);

// uCalc callback routines
// IMPORTANT: Remember to use _stdcall for your uCalc callbacks
long double _stdcall MyEasyCallback(double a, long& b, byte c)
{
   return a + b + c;
}

long double _stdcall MyIIF(long cond, long TruePart, long FalsePart)
{
   if (cond != 0)
   return ucEvaluate(TruePart);
   else return ucEvaluate(FalsePart);
}

char* _stdcall MyIIFStr(long cond, long TruePart, long FalsePart)
{
   if (cond != 0)
   return ucEvaluateStr(TruePart);
   else return ucEvaluateStr(FalsePart);
}

long _stdcall MyMsgBox(long Prompt, long Buttons, long Title)
{
   return MessageBox(0, ucEvaluateStr(Prompt), ucEvaluateStr(Title), Buttons);
}

long _stdcall MyMsgBoxB(CString& Prompt, long Buttons, CString& Title)
{
   return MessageBox(0, Prompt, Title, Buttons);
}

long _stdcall MyMsgBoxC(const char* Prompt, long Buttons, const char* Title)
{
   return MessageBox(0, Prompt, Title, Buttons);
}


// Callbacks using ucParam, and ucReturn are less efficient
void _stdcall MyAverage(DWORD Expr)
{
   long x;
   double Total = 0;
   
   for(x = 1; x <= ucParamCount(Expr); x++)
      Total = Total + ucParamDbl(Expr, x);

   ucReturnDbl(Expr, Total / ucParamCount(Expr));
}

void _stdcall MyLeft(DWORD Expr)
{
  char StringValue[200];
  long StringLength;

  strcpy(StringValue, ucParamStr(Expr, 1));
  StringLength = ucParamDbl(Expr, 2);
  StringValue[StringLength] = '\0';
  ucReturnStr(Expr, StringValue);
}

char* _stdcall StringMult(const char* MyString, long Number)
{
   long x;
   CString TotalString;   

   for(x = 1; x <= Number; x++)
	   TotalString = TotalString + MyString;
      
   return ucEvalStr("'" + TotalString + "'"); // +++ Simplify   
}


/////////////////////////////////////////////////////////////////////////////
// CDemoVCDlg dialog

CDemoVCDlg::CDemoVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoVCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoVCDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

   ucDefineFunction("MyEasyCallback(ByVal a As Double, ByRef b As Long, ByVal c As Byte) As Extended", MyEasyCallback);
   ucDefineFunction("MyIIf(ByVal cond As Long, ByExpr TruePart, ByExpr FalsePart) As Extended", MyIIF);
   ucDefineFunction("MyIIf(ByVal cond As Long, ByExpr TruePart As String, ByExpr FalsePart As String) As String", MyIIFStr);
   ucDefineFunction("MyMsgBox(ByExpr Prompt As String, ByVal Buttons As Long = 0, ByExpr Title As String = 'uCalc') As Long", MyMsgBox);
   ucDefineFunction("MyMsgBoxB(ByRef Prompt As String, ByVal Buttons As Long = 0, ByRef Title As String = 'uCalc') As Long", MyMsgBoxB);
//   ucDefineFunction("MyMsgBoxC(ByRef Prompt As LPCSTR, ByVal Buttons As Long = 0, ByRef Title As LPCSTR = 'uCalc') As Long", MyMsgBoxC);

//   ucDefineOperator("Precedence('*') {ByRef MyString As LPCSTR} * {ByVal Number As Long} As String", StringMult);
   ucDefineOperator("20 {ByRef MyString As LPCSTR} * {ByVal Number As Long} As String", StringMult);

   ucDefine("Func:: MyAverage(x As Double ...) As Double", MyAverage);
   ucDefine("Func:: MyLeft(Text As String, Count As Double) As String",MyLeft);
}

void CartesianLineTo(CDC* pDC, double X, double Y)
{
  int x, y;
  CRect rect;  

  x = (long)(W * (X + 10) / 20);
  y = (long)(H * (2 - Y) / 4);

  if (X == -10 || y > H || y < 0)
  pDC->MoveTo((long)x, (long)min(max(y, 0), H));
  else pDC->LineTo(x, y);  
}

void CDemoVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoVCDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoVCDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoVCDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_btnEval, OnbtnEval)
	ON_BN_CLICKED(IDC_chkExprEvalExamples, OnchkExprEvalExamples)
	ON_BN_CLICKED(IDC_chkDefExamples, OnchkDefExamples)
	ON_BN_CLICKED(IDC_btnDefine, OnbtnDefine)
	ON_BN_CLICKED(IDC_btnSum, OnbtnSum)
	ON_BN_CLICKED(IDC_btnPlot, OnbtnPlot)
	ON_EN_CHANGE(IDC_txtExpression, OnChangetxtExpression)
	ON_EN_CHANGE(IDC_txtDefinition, OnChangetxtDefinition)
	ON_BN_CLICKED(IDC_chkInvalidOp, OnchkInvalidOp)
	ON_BN_CLICKED(IDC_chkDenormalOp, OnchkDenormalOp)
	ON_BN_CLICKED(IDC_chkDivisionBy0, OnchkDivisionBy0)
	ON_BN_CLICKED(IDC_chkOverflow, OnchkOverflow)
	ON_BN_CLICKED(IDC_chkUnderflow, OnchkUnderflow)
	ON_BN_CLICKED(IDC_chkPrecisionLoss, OnchkPrecisionLoss)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoVCDlg message handlers

BOOL CDemoVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetDlgItemText(IDC_txtExpression, "3+4/5-8");
	SetDlgItemText(IDC_txtSumMax, "100000");
	SetDlgItemText(IDC_txtSumExpression, "x^2+5*x-10");
	SetDlgItemText(IDC_txtPlotEq, "-sin(x)/2");
	SetDlgItemText(IDC_txtDefinition, "Var: MyVariable = 1234.5");
        CheckDlgButton(IDC_chkInvalidOp, BST_CHECKED);
        CheckDlgButton(IDC_chkDenormalOp, BST_CHECKED);
        CheckDlgButton(IDC_chkDivisionBy0, BST_CHECKED);
        CheckDlgButton(IDC_chkOverflow, BST_CHECKED);
        CheckDlgButton(IDC_chkUnderflow, BST_CHECKED);
        CheckDlgButton(IDC_chkPrecisionLoss, BST_CHECKED);	

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoVCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoVCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemoVCDlg::OnbtnEval() 
{
	char MyText[200];

	GetDlgItemText(IDC_txtExpression, MyText, 200);
	SetDlgItemText(IDC_txtResult, ucEvalStr(MyText));	
}

void CDemoVCDlg::OnchkExprEvalExamples() 
{
    ShellExecute(0, "", getenv("COMSPEC"), "/C notepad DemoExpr.Txt", "", SW_NORMAL);	
}

void CDemoVCDlg::OnchkDefExamples() 
{
    ShellExecute(0, "", getenv("COMSPEC"), "/C notepad DemoDefs.Txt", "", SW_NORMAL);	
}

void CDemoVCDlg::OnbtnDefine() 
{
	char MyText[256];

	GetDlgItemText(IDC_txtDefinition, MyText, 256);
	ucDefine(MyText);	
}

void CDemoVCDlg::OnbtnSum() 
{
   char txtSumMax[200], txtSumExpression[200], txtSumTotal[200];
   char txtElapsed[200], txtElapsedTime[200];
   long TimerStart, TimerFinish;
   double x = 1, SumTotal = 0, SumMax;
   DWORD ExprPtr, xPtr;   

   GetDlgItemText(IDC_txtSumMax, txtSumMax, 200);
   GetDlgItemText(IDC_txtSumExpression, txtSumExpression, 200);
   SumMax = atoi(txtSumMax);
   
   xPtr = ucDefineVariable("x As Double", &x);
   ExprPtr = ucParse(txtSumExpression);
   TimerStart = GetTickCount();

   while (x <= SumMax)
   {
      SumTotal = SumTotal + ucEvaluate(ExprPtr);
      x++;
   }

 
   TimerFinish = GetTickCount();
   gcvt(SumTotal, 15, txtSumTotal);
   gcvt((float)(TimerFinish-TimerStart)/(float)1000, 15, txtElapsedTime);
   strcpy(txtElapsed, "Elapsed time: ");
   strcat(txtElapsed, txtElapsedTime);
   strcat(txtElapsed, " seconds");   
   SetDlgItemText(IDC_txtSumResult, txtSumTotal);
   SetDlgItemText(IDC_lblElapsed, txtElapsed);

   ucReleaseItem(ExprPtr);
   ucReleaseItem(xPtr);	
}

void CDemoVCDlg::OnbtnPlot() 
{   
   char txtPlotEq[200];
   double x = -10;
   DWORD EqPtr, xPtr;
   CRect rect;

   CWnd* h = GetDlgItem(IDC_PICTURE1);
   h->GetClientRect(rect);
   CDC* pDC = h->GetDC();

   h->GetClientRect(rect);
   pDC->FillRect(rect, CBrush::FromHandle((HBRUSH)GetStockObject(LTGRAY_BRUSH)));
  
   W = rect.Width();
   H = rect.Height();

   pDC->MoveTo(0, (long)H/2);


   GetDlgItemText(IDC_txtPlotEq, txtPlotEq, 200);
   
   xPtr = ucDefineVariable("x As Double", &x);
   EqPtr = ucParse(txtPlotEq);  

   while (x <= 10)
   {
      CartesianLineTo(pDC, x, ucEvaluate(EqPtr));
      x = x + 0.125;
   }

   ucReleaseItem(EqPtr);
   ucReleaseItem(xPtr);	
}

void CDemoVCDlg::OnChangetxtExpression() 
{
	char Expression[200], txtExpression[200];

	GetDlgItemText(IDC_txtExpression, txtExpression, 200);
	strcpy(Expression, "strcpy(Expression, \x22");
	strcat(Expression, txtExpression);
	strcat(Expression, "\x22);");

   	SetDlgItemText(IDC_lblEvalSource1, Expression);	
}

void CDemoVCDlg::OnChangetxtDefinition() 
{
	char Definition[200], txtDefinition[200];

	GetDlgItemText(IDC_txtDefinition, txtDefinition, 200);
	strcpy(Definition, "strcpy(Definition, \x22");
	strcat(Definition, txtDefinition);
	strcat(Definition, "\x22);");

   	SetDlgItemText(IDC_lblDefineSource, Definition);	
}

void CDemoVCDlg::OnchkInvalidOp() 
{
	uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_InvalidOp);	
}

void CDemoVCDlg::OnchkDenormalOp() 
{
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_DenormalOp);	
}

void CDemoVCDlg::OnchkDivisionBy0() 
{
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_ZeroDivide);	
}

void CDemoVCDlg::OnchkOverflow() 
{
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_Overflow);	
}

void CDemoVCDlg::OnchkUnderflow() 
{
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_Underflow);	
}

void CDemoVCDlg::OnchkPrecisionLoss() 
{
   uCalc(uc_ToggleFPU, 0, uc_FPU_Mask_PrecisionLoss);	
}
