Option Strict Off
Option Explicit On
Module DemoVB
    ' Callbacks using ucParam, and ucReturn are less efficient.  However, there's
    ' no alternative for .NET.  These examples are not exactly the same as the ones
    ' for other compilers.
    Sub MyEasyCallback(ByVal Expr As Integer)
        ucReturnDbl(Expr, ucParamDbl(Expr, 1) + ucParamDbl(Expr, 2) + ucParamDbl(Expr, 3))
    End Sub

    Sub MyIIF(ByVal Expr As Integer)
        If ucParamLng(Expr, 1) Then
            ucReturnDbl(Expr, ucEvaluate(ucParamExpr(Expr, 2)))
        Else
            ucReturnDbl(Expr, ucEvaluate(ucParamExpr(Expr, 3)))
        End If
    End Sub

    Sub MyIIFStr(ByVal Expr As Integer)
        If ucParamLng(Expr, 1) Then
            ucReturnStr(Expr, ucEvaluateStr(ucParamExpr(Expr, 2)))
        Else
            ucReturnStr(Expr, ucEvaluateStr(ucParamExpr(Expr, 3)))
        End If
    End Sub

    Sub MyMsgBox(ByVal Expr As Integer)
        ucReturnDbl(Expr, MsgBox(ucParamStr(Expr, 1), ucParamLng(Expr, 2), ucParamStr(Expr, 3)))
    End Sub

    ' Only the following two callbacks are defined the same way as in the demos
    ' for the other compilers.  Here in VB.NET, all of callbacks are defined this way.
    Sub MyAverage(ByVal Expr As Integer)
        Dim x As Long, Total As Double

        For x = 1 To ucParamCount(Expr)
            Total = Total + ucParamDbl(Expr, x)
        Next

        ucReturnDbl(Expr, Total / ucParamCount(Expr))
    End Sub

    Sub MyLeft(ByVal Expr As Integer)
        ucReturnStr(Expr, Left$(ucParamStr(Expr, 1), ucParamLng(Expr, 2)))
    End Sub

    Sub StringMult(ByVal Expr As Integer)
        Dim x As Long, TotalString As String

        For x = 1 To ucParamLng(Expr, 2)
            TotalString = TotalString + ucParamStr(Expr, 1)
        Next
        ucReturnStr(Expr, TotalString)
   End Sub
End Module